<?php

namespace App\Entity;

use App\Repository\OrderRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use phpDocumentor\Reflection\Types\Collection;

//table commande
#[ORM\Entity(repositoryClass: OrderRepository::class)]
#[ORM\Table(name: '`order`')]
class Order
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(type: Types::DATE_MUTABLE)]
    private ?\DateTimeInterface $DateHeure = null;

    #[ORM\Column(length: 255)]
    private ?string $StatusOrder = null;

    #[ORM\Column(length: 255)]
    private ?string $PriceOrder = null;

    #[ORM\ManyToMany(targetEntity: Dishes::class, inversedBy: "Order")]
    private ?Dishes $dish = null;

    #[ORM\ManyToOne(targetEntity: OrderDetail::class, inversedBy: "Order")]
    private ?OrderDetail $OrderDetail = null;

    #[ORM\ManyToOne(targetEntity: StatusOrder::class, inversedBy: "Order")]
    private Collection $StatusOrders;

    #[ORM\ManyToMany(targetEntity: Customer::class, inversedBy: "Order")]
    private ?Customer $Customer = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDateHeure(): ?\DateTimeInterface
    {
        return $this->DateHeure;
    }

    public function setDateHeure(\DateTimeInterface $DateHeure): static
    {
        $this->DateHeure = $DateHeure;

        return $this;
    }

    public function getStatusOrder(): ?string
    {
        return $this->StatusOrder;
    }

    public function setStatusOrder(string $StatusOrder): static
    {
        $this->StatusOrder = $StatusOrder;

        return $this;
    }

    public function getPriceOrder(): ?string
    {
        return $this->PriceOrder;
    }

    public function setPriceOrder(string $PriceOrder): static
    {
        $this->PriceOrder = $PriceOrder;

        return $this;
    }
}
