<?php

namespace App\Entity;

use App\Repository\OrderDetailRepository;
use Doctrine\ORM\Mapping as ORM;
use phpDocumentor\Reflection\Types\Collection;

// table détails des commandes
#[ORM\Entity(repositoryClass: OrderDetailRepository::class)]
class OrderDetail
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column]
    private ?int $Quantity = null;

    #[ORM\Column(length: 255)]
    private ?string $UnitaryPrice = null;

    #[ORM\OneToMany(targetEntity: Order::class, mappedBy: "OrderDetail")]
    private Collection $order ;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getQuantity(): ?int
    {
        return $this->Quantity;
    }

    public function setQuantity(int $Quantity): static
    {
        $this->Quantity = $Quantity;

        return $this;
    }

    public function getUnitaryPrice(): ?string
    {
        return $this->UnitaryPrice;
    }

    public function setUnitaryPrice(string $UnitaryPrice): static
    {
        $this->UnitaryPrice = $UnitaryPrice;

        return $this;
    }
}
